/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package checkpolicy.prolog;

import java.util.*;

import jpl.*;
import jpl.fli.*;

/**
 *
 * @author Micah
 */
public class QueryBuilder {

//    /**
//     * @param args the command line arguments
//     */
//    public static void main(String[] args)
//    {
//        loadPrologFile("test.pl");
//        
//        Variable P = new Variable("P");
//        Variable C = new Variable("C");
//        Query q1 =
//                new Query("child_of", new Term[] {P, C});
//        System.out.println(writeQuerySolutions(q1));
//        
//        Query q2 =
//                new Query("child_of(joe,bob).");
//        System.out.println(q2.hasSolution() ? "yes" : "no");
//
//        jpl.Query q3 =
//                new Query("child_of(joe,bob).");
//        System.out.println(q2.hasSolution() ? "yes" : "no");

//        loadPrologFile("hw.pl");
//        
//        Query q1 = new Query("mergesort([72,19,-7,137,92,0],X).");
//        Term[] t = ((Term)q1.oneSolution().get("X")).toTermArray();
//        System.out.print("X = [" + t[0].intValue());
//        for (int i = 1; i < t.length; i++)
//            System.out.print(", " + t[i]);
//        System.out.println("]");
//    }
    
    public static String writeQuerySolutions(Query query, boolean eliminateDuplicates)
    {
        StringBuilder s = new StringBuilder();
        
        if (!query.hasSolution())
            return "false";
        
        Hashtable[] h = query.allSolutions();
        
        if (h == null)
            return "";
        
        for (int i = 0; i < h.length; i++)
        {
            Set keyset = h[i].keySet();
            Iterator iter = keyset.iterator();
            while (iter.hasNext())
            {
                Object key = iter.next();
                s.append(key.toString() + " = " + h[i].get(key).toString() + "\n");
            }
            s.append("\n");
        }
        
        if (eliminateDuplicates)
        {
            String[] sArray = s.toString().split("\n\n");
            TreeSet<String> resultSet = new TreeSet<String>();
            for (int i = 0; i < sArray.length; i++)
            {
                if (!resultSet.contains(sArray[i]))
                    resultSet.add(sArray[i]);
            }
            s = new StringBuilder();
            Iterator<String> iter = resultSet.iterator();
            while (iter.hasNext())
                s.append(iter.next() + "\n\n");
        }
        
        return s.toString();
    
    }

}
